;
; This file is part of the AdvanceVBE project
;
; Copyright (C) 1999-2000 Andrea Mazzoleni
;
; The contents of this file are free for non-commercial use.
; Any commercial use is forbidden.
;

;
; COM file startup module, cs == ds != ss
;

ideal
model tiny

; Segments

segment _TEXT word public 'CODE'
ends

segment _DATA word public 'DATA'
ends

segment _BSS  word public 'BSS'
label start_fill
ends

segment _BSSEND word public 'BSS'
label end_fill
ends

codeseg

extrn C main : proc

org 100h

start:
	; fill bss segment
	mov cx,offset DGROUP:end_fill
	mov di,offset DGROUP:start_fill
	sub cx,di
	mov ax,es
	mov es,ax
	xor al,al
	cld
	rep stosb

	; call main
	call main

	; 00==TSR
	cmp ax,00
	jne terminate

	; terminate and stay resident
	mov dx,offset DGROUP:end_fill
	add dx,15
	shr dx,4

	mov ax,3100h
	int 21h

terminate:
	; errorlevel
	dec al

	; terminate
	mov ah,4ch
	int 21h

end start
