;
; This file is part of the AdvanceVBE project
;
; Copyright (C) 1999-2000 Andrea Mazzoleni
;
; The contents of this file are free for non-commercial use.
; Any commercial use is forbidden.
;

ideal
model tiny

codeseg

; **************************************************************************
; int 10h
;

codeseg

public C int_10_old

int_10_old DD 0

extrn C int_10_trap:proc

public C int_10

proc int_10
	pushf

	cmp ax,4F00h
	jb skip_10
	cmp ax,4F0Fh
	ja skip_10
	jmp short trap_10

skip_10:
	popf
	jmp [dword ptr cs:int_10_old]

trap_10:
	popf
	push ds
	push bp

	push es di si dx cx bx ax

	; imposta ds
	mov ax,cs           ; cs == ds != ss
	mov ds,ax

	; immette l'indirizzo far ai registri
	mov bp,sp
	push ss
	push bp

	call int_10_trap

	add sp,4

	pop ax bx cx dx si di es

	pop bp
	pop ds
	iret
endp

; **************************************************************************
; int 2Fh
;

codeseg

public C int_2f_old

int_2f_old DD 0

public C int_2f_id

int_2f_id DB 0

extrn C int_2f_trap:proc

public C int_2f

align 2

proc int_2f
	pushf

	cmp ah,[cs:int_2f_id]
	je trap_2f

	popf
	jmp [dword ptr cs:int_2f_old]

trap_2f:
	popf
	push ds
	push bp

	push es di si dx cx bx ax

	; imposta ds
	mov ax,cs           ; cs == ds != ss
	mov ds,ax

	; immette l'indirizzo far ai registri
	mov bp,sp
	push ss
	push bp

	call int_2f_trap

	add sp,4

	pop ax bx cx dx si di es

	pop bp
	pop ds
	iret
endp

end
