/*
 * This file is part of the AdvanceVBE project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#include "compil.h"

void _pascal int_1a_call(regs_32 far* regs) {
	asm push bp
	asm push si
	asm push di

	asm lds bp,[regs]
	asm mov eax,[ds:bp+0*4]
	asm mov ebx,[ds:bp+1*4]
	asm mov ecx,[ds:bp+2*4]
	asm mov edx,[ds:bp+3*4]
	asm mov esi,[ds:bp+4*4]
	asm mov edi,[ds:bp+5*4]
	asm mov es,[ds:bp+6*4]

	asm push ds
	asm push bp
	asm int 1ah
	asm pop bp
	asm pop ds

	asm mov [ds:bp+0*4],eax
	asm mov [ds:bp+1*4],ebx
	asm mov [ds:bp+2*4],ecx
	asm mov [ds:bp+3*4],edx
	asm mov [ds:bp+4*4],esi
	asm mov [ds:bp+5*4],edi
	asm mov [ds:bp+6*4],es

	asm push cs
	asm pop ds

	asm pop di
	asm pop si
	asm pop bp
}

extern void far * int_10_old;

void _pascal int_10_call(regs_16 far* regs) {
	asm push bp
	asm push si
	asm push di

	asm lds bp,[regs]
	asm mov ax,[ds:bp+0*2]
	asm mov bx,[ds:bp+1*2]
	asm mov cx,[ds:bp+2*2]
	asm mov dx,[ds:bp+3*2]
	asm mov si,[ds:bp+4*2]
	asm mov di,[ds:bp+5*2]
	asm mov es,[ds:bp+6*2]

	asm push ds
	asm push bp
	asm pushf
	asm call [cs:dword ptr int_10_old]
	asm pop bp
	asm pop ds

	asm mov [ds:bp+0*2],ax
	asm mov [ds:bp+1*2],bx
	asm mov [ds:bp+2*2],cx
	asm mov [ds:bp+3*2],dx
	asm mov [ds:bp+4*2],si
	asm mov [ds:bp+5*2],di
	asm mov [ds:bp+6*2],es

	asm push cs
	asm pop ds

	asm pop di
	asm pop si
	asm pop bp
}

void dosmemget(unsigned long offset, unsigned length, void far* buffer) {
	memcpy(buffer,MK_FP(offset >> 4,offset & 0xF),length);
}

int __dpmi_int(int vector, regs_32 far *regs) {
	if (vector != 0x1a)
		return -1;
	regs_32_preset(regs);
	int_1a_call(regs);
	return 0;
}