/*
 * This file is part of the AdvanceVBE project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */


#ifndef __COMPIL_H
#define __COMPIL_H

#include "lib.h"

/* SS != DS */
#define STACK_PTR far
#define STACK_DECL static

typedef uint8 BYTE;
typedef uint16 WORD;
typedef uint32 DWORD;

#define __dpmi_regs regs_32

void _pascal int_1a_call(regs_32 far* regs);
void _pascal int_10_call(regs_16 far* regs);

int __dpmi_int(int _vector, regs_32 far * _regs);

void dosmemget(unsigned long offset, unsigned length, void far* buffer);

#define	_farpokeb(seg,off,value) ((*(BYTE*)MK_FP(seg,off)) = (value))
#define	_farpeekb(seg,off) (*(BYTE*)MK_FP(seg,off))
#define	_farpokew(seg,off,value) ((*(WORD*)MK_FP(seg,off)) = (value))
#define	_farpeekw(seg,off) (*(WORD*)MK_FP(seg,off))
#define	_farpokel(seg,off,value) ((*(DWORD*)MK_FP(seg,off)) = (value))
#define	_farpeekl(seg,off) (*(DWORD*)MK_FP(seg,off))

#endif